﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Finjmapedit : Form
    {
        public volatile bool changed = false;
        public volatile bool autoedit = false;
        public volatile int idx_r, idx_a;
        public volatile uint val;
        public volatile int forcus_r, forcus_a;

        public Finjmapedit()
        {
            InitializeComponent();
            
            dataGridView1.ColumnCount = 26;
            dataGridView1.RowCount = 17;
            dataGridView1.AllowUserToAddRows = false;   // 行の追加操作を出来ないようにする
            dataGridView1.RowHeadersVisible = false;    // 一番左の行を非表示
            dataGridView1.Columns[0].Width = 40;
            dataGridView1.Columns[0].SortMode = DataGridViewColumnSortMode.NotSortable; // ソート禁止にする
            for (int a = 1; a < 26; a++)
            {
                dataGridView1.Columns[a].Name = ((25-a)*10).ToString("D");
                dataGridView1.Columns[a].Width = 40;
                dataGridView1.Columns[a].SortMode = DataGridViewColumnSortMode.NotSortable;
            }
            for (int a = 0; a < 16; a++)
            {
                dataGridView1.Rows[a].Cells[0].Value = String.Format("{0,4:D}", (a + 1) * 500);
                dataGridView1.Rows[a].Cells[0].ReadOnly = true;
            }
        }

        public void settitle(string text)
        {
            this.Text = text;
        }

        public void setmap(int idx_r,int idx_a,uint val)
        {
            dataGridView1.Rows[idx_r].Cells[idx_a + 1].Value = val;
        }

        public uint getmap(int r,int a)
        {
            
            uint temp;
            if (uint.TryParse(dataGridView1.Rows[r].Cells[a+1].Value.ToString(), out temp))
            {
                return temp;
            }
            else
            {
                return 0;
            }
        }

        public void opeenabled(bool a)
        {
            dataGridView1.Enabled = a;
        }

        // セルが編集された
        private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            uint temp;
            idx_r = e.RowIndex;
            idx_a = e.ColumnIndex-1;
            if (uint.TryParse(dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value.ToString(), out temp))
            {
                val = temp;
                //opeenabled(false);
                changed = true;
            }
            else
            {
                dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value = 0;
            }
        }
        
        // ボタンが押された
        private void dataGridView1_KeyUp(object sender, KeyEventArgs e)
        {
            uint temp;
            if (e.KeyCode == Keys.F1)    // [F1]キー
            {
                if (uint.TryParse(dataGridView1.Rows[forcus_r].Cells[forcus_a+1].Value.ToString(), out temp))
                {
                    val = temp;
                    autoedit = true;
                }
                else
                {
                    dataGridView1.Rows[forcus_r].Cells[forcus_a+1].Value = 0;
                }
            }
        }
        // クローズボタンが押されたイベント
        private void Finjmapedit_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;    // 閉じずに
            this.Hide();    // 見えなくする
        }

        // 現在のセルが移動した
        private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
        {
            forcus_r = e.RowIndex;
            forcus_a = e.ColumnIndex - 1;
        }

        // 幅が変更されたら全部同じ幅にする
        private void dataGridView1_ColumnWidthChanged(object sender, DataGridViewColumnEventArgs e)
        {
            if (e.Column.Index != 0)
            {
                for (int a = 1; a < 26; a++)
                {
                    dataGridView1.Columns[a].Width = dataGridView1.Columns[e.Column.Index].Width;
                }
            }
        }

        public void setcolumwidth(int a)
        {
            dataGridView1.Columns[1].Width = a;
        }
    }
}
